/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
 
#include <includes.h>
#include <gtk/gtk.h>
#include "../xstuff.h"
#include "../preferences.h"




struct arglist * prefs_dialog_scan_opt()
{
 GtkWidget * frame;
 GtkWidget * table;
 GtkWidget * ping_hosts;
 GtkWidget * box;
 GtkWidget * scan_level_normal;
 GtkWidget * scan_level_heavy;
 GtkWidget * label;
 GSList    * radio_group;
 GtkWidget * port_range;
 GtkWidget  * entry;

 struct arglist * ctrls = emalloc(sizeof(struct arglist));
 
 frame = gtk_frame_new("Scan options");
 gtk_container_border_width(GTK_CONTAINER(frame), 10);
 arg_add_value(ctrls, "FRAME", ARG_PTR, -1, frame);
 
 gtk_widget_show(frame);
 
 
 box = gtk_vbox_new(FALSE, 10);
 
 gtk_container_add(GTK_CONTAINER(frame), box);
 gtk_container_border_width(GTK_CONTAINER(box), 10);
 gtk_widget_show(box);
 
 
 ping_hosts = gtk_check_button_new_with_label("Ping hosts before scanning them");
 arg_add_value(ctrls, "PING_HOSTS", ARG_PTR, -1, ping_hosts);
 gtk_box_pack_start(GTK_BOX(box), ping_hosts, FALSE, FALSE, 0);
 gtk_widget_show(ping_hosts);
 
 
 table = gtk_table_new(5, 2, FALSE);
 gtk_box_pack_start(GTK_BOX(box), table, FALSE, FALSE, 0);
 gtk_widget_show(table);
 
 label = gtk_label_new("Scan level : ");
 gtk_table_attach_defaults(GTK_TABLE(table),label, 0,1,0,1);
 gtk_widget_show(label);
 
 scan_level_normal = gtk_radio_button_new_with_label(NULL, "Normal");
 radio_group = gtk_radio_button_group(GTK_RADIO_BUTTON(scan_level_normal));
 scan_level_heavy = gtk_radio_button_new_with_label(radio_group, "Heavy");
 arg_add_value(ctrls, "SCAN_NORMAL", ARG_PTR, -1, scan_level_normal);
 arg_add_value(ctrls, "SCAN_HEAVY", ARG_PTR, -1, scan_level_heavy);
 
 gtk_table_attach_defaults(GTK_TABLE(table), scan_level_normal, 1,2,0,1);
 gtk_widget_show(scan_level_normal);
 
 gtk_table_attach_defaults(GTK_TABLE(table),scan_level_heavy, 1,2,1,2);
 gtk_widget_show(scan_level_heavy);

 gtk_table_set_row_spacing(GTK_TABLE(table), 1, 10);
 label = gtk_label_new("Port range : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 2,3);
 gtk_widget_show(label);
 
 port_range = gtk_entry_new();
 gtk_table_attach_defaults(GTK_TABLE(table), port_range, 1,2,2,3);
 gtk_widget_show(port_range);
 arg_add_value(ctrls, "PORT_RANGE", ARG_PTR, -1, port_range);
 
 gtk_table_set_row_spacing(GTK_TABLE(table), 2, 10);
 label = gtk_label_new("Max threads : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,3,4);
 gtk_widget_show(label);
 
 entry = gtk_entry_new();
 gtk_table_attach_defaults(GTK_TABLE(table), entry, 1,2,3,4);
 gtk_widget_show(entry);
 arg_add_value(ctrls, "MAX_THREADS", ARG_PTR, -1, entry);
 
 
 gtk_table_set_row_spacing(GTK_TABLE(table), 3, 10);
 label = gtk_label_new("Remote file to obtain : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,4,5);
 gtk_widget_show(label);
 
 entry = gtk_entry_new();
 gtk_table_attach_defaults(GTK_TABLE(table), entry, 1,2,4,5);
 gtk_widget_show(entry);
 arg_add_value(ctrls, "TEST_FILE", ARG_PTR, -1, entry);
  
 return(ctrls);
}
